part of fling_pickle;

/// Converts [Pickle]s to and from a binary representation.
///
/// This is useful for persistence, e.g. writing to a [File] or sending over
/// the network.
class BinaryPickler
    implements
        PickleReader<Stream<int>>,
        PickleSyncReader<List<int>>,
        PickleWriter<Stream<int>>,
        PickleSyncWriter<List<int>> {
  @override
  Pickle readSync(final List<int> input) {
    return Pickle._(jsonDecode(utf8.decode(input)));
  }

  @override
  Future<Pickle> read(final Stream<int> input) async {
    return readSync(await input.toList());
  }

  @override
  List<int> writeSync(final Pickle pickle) {
    return utf8.encode(jsonEncode(pickle._values));
  }

  @override
  Stream<int> write(final Pickle pickle) {
    return Stream<int>.fromIterable(writeSync(pickle));
  }
}
