part of fling_pickle;

/// Reads and writes [Pickle]s to and from Dart's JSON representation.
///
/// This allows integration with a lot of Dart core libraries and extensions,
/// e.g. `dart.convert`'s `jsonEncode()` or `cloud_firestore`'s `add()` and
/// `get()`.
class JsonPickler
    implements
        PickleSyncReader<Map<String, dynamic>>,
        PickleSyncWriter<Map<String, dynamic>> {
  @override
  Pickle readSync(final Map<String, dynamic> json) =>
      Pickle._(Map<String, dynamic>.from(json));

  @override
  Map<String, dynamic> writeSync(final Pickle pickle) =>
      Map<String, dynamic>.from(pickle._values);
}
