part of fling_pickle;

/// Can read [Pickle]s from data sources.
abstract class PickleReader<T> {
  /// Creates a [Pickle] from an input source.
  Future<Pickle> read(final T input);
}

/// Can read [Pickle]s from data sources.
abstract class PickleSyncReader<T> {
  /// Creates a [Pickle] from an input source.
  Pickle readSync(final T input);
}

/// Can write a [Pickle] to persistence.
abstract class PickleWriter<T> {
  /// Creates the persistent form of the provided [Pickle].
  T write(final Pickle input);
}

/// Can write a [Pickle] to persistence.
abstract class PickleSyncWriter<T> {
  /// Creates the persistent form of the provided [Pickle].
  T writeSync(final Pickle input);
}
